
#include <stdio.h>
#include <dos.h>
#include <mem.h>
#include <string.h>
#include "we.h"
#include "allocmem.h"
#include "undo.h"
#include "ems.h"

#define  ON              1
#define  OFF             0

extern struct BACKUP      *ACTIVE;
extern struct BLOCK       *Bhead;
extern struct DATA        *Dhead;
extern struct UNDO_STRUCT UNDO;

//struct BACKUP        BACK[MAXOPEN+1];
//char                 BACK_MARK[MAXOPEN+1]={ 0 };

// ----------------------------------------------------------------
// -1    tmO^\
// ELSE  Ǧ^ثeiϥΪ̤jŶ
//
// Ѽ  para  ݭn(H 16 bytes  1 )
// ----------------------------------------------------------------
struct LINK *AllocMem(int para)
{
   struct BLOCK *BLOCKnow;
   struct BLOCK *BLOCKnew;
   struct DATA  *DATAnow;
   struct DATA  *DATAnew;
   struct LINK  *LINKtmp;
   int          i,k,cnt;
   int          data_mark;
   int          block_mark;
   int          FIND=OFF;


   if(Bhead==NULL)  { if((BLOCKnew=BLOCKalloc())==NULL) return(NULL); }
   if(Dhead==NULL)  { if((DATAnew =DATAalloc()) ==NULL) return(NULL); }

   // ------------------ BLOCK O_iϥΪŶ ---------------
   BLOCKnow=Bhead;

   while(BLOCKnow!=NULL)
   {
      if((*BLOCKnow).useable>=1)
      {
         for(i=0; i<1024 ;i++)         // Xťժ BLOCK
         {
            k=i>>3;
            if((*BLOCKnow).mark[k]==(unsigned char)0xff)
            {
               i +=7;
               continue;
            }
            else
            {
               if(((*BLOCKnow).mark[k] & (0x80>>(i%8)))==0) { block_mark=i; break; }
            }
         }
         break;
      }
      BLOCKnow=BLOCKnow->next;
   }

   if(BLOCKnow==NULL)
   {
      if((BLOCKnew=BLOCKalloc())==NULL) return(NULL);
      BLOCKnow    =BLOCKnew;
      block_mark  =0;
   }

   // ------------------ DATA iϥΪŶ ---------------
   DATAnow=Dhead;
   while(DATAnow!=NULL)
   {
      if((*DATAnow).useable>=para)
      {
         for(i=0, cnt=0;i<1024 && cnt<para;i++)         // Xťժ DATA
         {
            k=i>>3;
            if((*DATAnow).mark[k]==(unsigned char)0xff)
            {
               cnt=0;
               i +=7;
               continue;
            }
            else
            {
               if(((*DATAnow).mark[k] & (0x80>>(i%8)))==0) cnt++; else cnt=0;
            }
            if(cnt==para)                               // 쨬sŶ
            {
               data_mark=i-cnt+1;
               FIND=ON;
               break;
            }
         }
      }
      if(FIND) break;
      DATAnow=DATAnow->next;
   }

   if(DATAnow==NULL)
   {
      if((DATAnew=DATAalloc())==NULL) return(NULL);
      DATAnow  =DATAnew;
      data_mark=0;
   }

  // --------------------- BLOCK аOwQϥ ---------------------
  (*BLOCKnow).mark[block_mark>>3] |= (0x80>>(block_mark%8));
  (*BLOCKnow).useable --;                       // iϥΪŶ

  // --------------------- DATA  аOwQϥ ---------------------
  for(i=0; i<para; i++)
  {
     (*DATAnow).mark[(data_mark+i)>>3] |= (0x80>>((data_mark+i)%8));
  }
  (*DATAnow).useable -=para;                    // iϥΪŶ

  // --------------------- struct LINK * ]w ----------------------
   LINKtmp=(struct LINK *)((*BLOCKnow).data[block_mark]);
   (*LINKtmp).block_handle=(*BLOCKnow).block_handle;
   (*LINKtmp).data_handle =(*DATAnow).data_handle;
   (*LINKtmp).block_mark  =block_mark;
   (*LINKtmp).data_mark   =data_mark;
   (*LINKtmp).data_size   =para;

   return(LINKtmp);
}

void FreeMem(struct LINK *LINKtmp)
{
   struct BLOCK *BLOCKtmp;
   struct BLOCK *BLOCKprev;
   struct BLOCK *BLOCKnext;
   struct DATA  *DATAtmp;
   struct DATA  *DATAprev;
   struct DATA  *DATAnext;
   int          i;
   char         *ts,str[257];

   // -------------------- Free ƥ@ UNDO ---------------------
   ts  =DATAPointerData(LINKtmp);
   strcpy(str,ts);
   UndoAppend(str,0);                                  // UndoAppend

   // ---------------------- BLOCK Ŷ^ ----------------------
   BLOCKtmp=BLOCKPointer(LINKtmp);
   (*BLOCKtmp).useable ++;
   i=(*LINKtmp).block_mark;
   switch(i%8)
   {
      case  0 : (*BLOCKtmp).mark[i/8] &=0x7f; break;
      case  1 : (*BLOCKtmp).mark[i/8] &=0xbf; break;
      case  2 : (*BLOCKtmp).mark[i/8] &=0xdf; break;
      case  3 : (*BLOCKtmp).mark[i/8] &=0xef; break;
      case  4 : (*BLOCKtmp).mark[i/8] &=0xf7; break;
      case  5 : (*BLOCKtmp).mark[i/8] &=0xfb; break;
      case  6 : (*BLOCKtmp).mark[i/8] &=0xfd; break;
      case  7 : (*BLOCKtmp).mark[i/8] &=0xfe; break;
   }

   // ---------------------- DATA  Ŷ^ ----------------------
   DATAtmp=DATAPointer(LINKtmp);
   (*DATAtmp).useable += (*LINKtmp).data_size;
   for(i=(*LINKtmp).data_mark; i<((*LINKtmp).data_mark+(*LINKtmp).data_size); i++)
   {
       switch(i%8)
       {
          case  0 : (*DATAtmp).mark[i/8] &=0x7f; break;
          case  1 : (*DATAtmp).mark[i/8] &=0xbf; break;
          case  2 : (*DATAtmp).mark[i/8] &=0xdf; break;
          case  3 : (*DATAtmp).mark[i/8] &=0xef; break;
          case  4 : (*DATAtmp).mark[i/8] &=0xf7; break;
          case  5 : (*DATAtmp).mark[i/8] &=0xfb; break;
          case  6 : (*DATAtmp).mark[i/8] &=0xfd; break;
          case  7 : (*DATAtmp).mark[i/8] &=0xfe; break;
       }
   }
   LINKtmp=NULL;

   if((*BLOCKtmp).useable==1024)                  //  BLOCK wϥΤF
   {
      if(BLOCKtmp==Bhead) Bhead=BLOCKtmp->next;
      BLOCKprev=BLOCKtmp->prev;
      BLOCKnext=BLOCKtmp->next;
      if(BLOCKprev!=NULL) BLOCKprev->next=BLOCKnext;
      if(BLOCKnext!=NULL) BLOCKnext->prev=BLOCKprev;
      freemem(FP_SEG(BLOCKtmp));
   }

   if((*DATAtmp).useable==1024)                  //  DATA  wϥΤF
   {
      if(DATAtmp==Dhead) Dhead=DATAtmp->next;
      DATAprev=DATAtmp->prev;
      DATAnext=DATAtmp->next;
      if(DATAprev!=NULL) DATAprev->next=DATAnext;
      if(DATAnext!=NULL) DATAnext->prev=DATAprev;
      if(DATAtmp->ems_handle!=0x00)
      {
         EMSfreeblock(DATAtmp->ems_handle);
      }
      else
      {
         freemem(FP_SEG(DATAtmp->data));
      }
      freemem(FP_SEG(DATAtmp));
   }
   UNDO.memory_full=OFF;
}

// ----------------------------------------------------------------
// -1    tmO^\
// ELSE  Ǧ^ثeiϥΪ̤jŶ
//
// Ѽ  str   ҭntmr
// ----------------------------------------------------------------
struct LINK *AllocMemString(char *str)
{
   struct LINK *tmp;
   int         len,para;
   char        *ts;

   // ------------- struct LINK @ 16 bytes (1 para) --------------
   len=strlen(str) +1;
   if((len%16)==0)  para=(len>>4);   else   para=(len>>4)+1;

   if((tmp=AllocMem(para))==NULL) return(NULL);       // ƪ

   ts =DATAPointerData(tmp);
   *ts='\0';
   return(tmp);
}

struct BACKUP *MallocBAK()
{
   unsigned        size;
   unsigned        sw;
   struct   BACKUP *BAKnew;
   struct   BACKUP *BAKtmp;

   size  =(sizeof(struct BACKUP)+15)>>4;
   if(allocmem(size,&sw)!=-1)
   {
      return(NULL);
   }
   BAKnew=(struct BACKUP *)MK_FP(sw,0);
   if(ACTIVE==NULL)
   {
      BAKnew->next=BAKnew;
      BAKnew->prev=BAKnew;
   }
   else
   {
      BAKtmp       =ACTIVE->next;
      ACTIVE->next =BAKnew;
      BAKtmp->prev =BAKnew;
      BAKnew->prev =ACTIVE;
      BAKnew->next =BAKtmp;
   }
   return(BAKnew);
}

void FreeBAK(struct BACKUP *BAKfree)
{
   freemem(FP_SEG(BAKfree));
}

struct DATA *DATAalloc()
{
   struct   DATA *DATAnew;
   struct   DATA *DATAtmp;
   unsigned size;
   unsigned i,sw;
   char     str[2048];

   // --------- ڻݨDhtm 1K, HTwO ---------
   size  =(sizeof(struct DATA)+15)>>4;
   if(allocmem(size+64,&sw)!=-1)
   {
      UndoClose();                           // free .UNDO
      if(allocmem(size+64,&sw)!=-1)
      {
         DisplayMessage("~ : O餣, Хw}Ҫɮ",ON);
         return(NULL);
      }
   }
   else
   {
      freemem(sw);
      allocmem(size,&sw);
   }
   DATAnew=(struct DATA *)MK_FP(sw,0);


   // ------------------ ts DATA->data Ŷ (16K) -----------------
   if(EMSinstall() && EMSavailable()>1 && EMSuseableHandle())
   {
      EMSallocblock(1,&sw);
      (*DATAnew).ems_handle=sw;
      DATAnew->data        =MK_FP(EMSframe(),0);
   }
   else
   {
      size  =1024;
      if(allocmem(size+64,&sw)!=-1)
      {
         UndoClose();                           // free .UNDO
         if(allocmem(size+64,&sw)!=-1)
         {
            DisplayMessage("~ : O餣, Хw}Ҫɮ",ON);
            freemem(FP_SEG(DATAnew));
            return(NULL);
         }
      }
      else
      {
         freemem(sw);
         allocmem(size,&sw);
      }
      DATAnew->ems_handle=0x00;
      DATAnew->data      =(char *)MK_FP(sw,0);
   }

   for(i=0;i<128;i++) (*DATAnew).mark[i]=0x00;
   (*DATAnew).useable=1024;
   if(Dhead==NULL)
   {
      DATAnew->next         =NULL;
      DATAnew->prev         =NULL;
      (*DATAnew).data_handle=0;
      Dhead                 =DATAnew;
   }
   else
   {
      for(i=0;i<256;i++) str[i]=' ';
      DATAtmp=Dhead;
      while(1)
      {
         str[(*DATAtmp).data_handle]='*';
         if(DATAtmp->next==NULL) break; else DATAtmp=DATAtmp->next;
      }
      DATAtmp->next =DATAnew;
      DATAnew->next =NULL;
      DATAnew->prev =DATAtmp;
      for(i=0;i<256;i++)
      {
         if(str[i]==' ') { (*DATAnew).data_handle=i; break; }
      }
   }
   return(DATAnew);
}


// ----- Ǧ^ struct LINK *  ҫV struct DATA * } ----------------------
struct DATA *DATAPointer(struct LINK *LINKtmp)
{
   struct DATA *DATAtmp;

   // ------ ھ LINKtmp  data_handle   struct DATA * ------
   DATAtmp=Dhead;
   while(DATAtmp!=NULL)
   {
      if((DATAtmp->data_handle)==(LINKtmp->data_handle)) break;
      DATAtmp=DATAtmp->next;
   }
   return(DATAtmp);
}

// ----- Ǧ^ struct LINK *  ҫVƦ} ----------------
char *DATAPointerData(struct LINK *LINKtmp)
{
   struct DATA *DATAtmp;
   char        *ts;

   if((DATAtmp=DATAPointer(LINKtmp))==NULL) return(NULL);

   // ------- ھ struct DATA *  LINKtmp sƦm -------
   if(DATAtmp->ems_handle!=0x00)             // ϥ EMS
   {
      EMSmapping(DATAtmp->ems_handle,0,0);
   }
   ts=(DATAtmp->data) + (LINKtmp->data_mark << 4);
   return(ts);
}




// ----- Ǧ^ struct LINK *  ҫV struct BLOCK * } ----------------------
struct BLOCK *BLOCKPointer(struct LINK *LINKtmp)
{
   struct BLOCK *BLOCKtmp;

   // ------ ھ LINKtmp  block_handle   struct BLOCK * ------
   BLOCKtmp=Bhead;
   while(BLOCKtmp!=NULL)
   {
      if((BLOCKtmp->block_handle)==(LINKtmp->block_handle)) break;
      BLOCKtmp=BLOCKtmp->next;
   }
   return(BLOCKtmp);
}

struct BLOCK *BLOCKalloc()
{
   struct   BLOCK *BLOCKnew;
   struct   BLOCK *BLOCKtmp;
   unsigned size,i,sw;
   char     str[257];

   // --------- ڻݨDhtm 1K, HTwO ---------
   size=(sizeof(struct BLOCK)+15)>>4;
   if(allocmem(size+64,&sw)!=-1)
   {
      UndoClose();                           // free .UNDO
      if(allocmem(size+64,&sw)!=-1)
      {
         DisplayMessage("~ : O餣, Хw}Ҫɮ",ON);
         return(NULL);
      }
   }
   else
   {
      freemem(sw);
      allocmem(size,&sw);
   }
   BLOCKnew=(struct BLOCK *)MK_FP(sw,0);

   for(i=0;i<128;i++) (*BLOCKnew).mark[i]=0x00;
   (*BLOCKnew).useable=1024;
   if(Bhead==NULL)
   {
      BLOCKnew->next          =NULL;
      BLOCKnew->prev          =NULL;
      (*BLOCKnew).block_handle=0;
      Bhead                   =BLOCKnew;

   }
   else
   {
      for(i=0;i<256;i++) str[i]=' ';
      BLOCKtmp=Bhead;
      while(1)
      {
         str[(*BLOCKtmp).block_handle]='*';
         if(BLOCKtmp->next==NULL) break; else BLOCKtmp=BLOCKtmp->next;
      }
      BLOCKtmp->next =BLOCKnew;
      BLOCKnew->next =NULL;
      BLOCKnew->prev =BLOCKtmp;
      for(i=0;i<256;i++)
      {
         if(str[i]==' ') { (*BLOCKnew).block_handle=i; break; }
      }
   }
   return(BLOCKnew);
}


//void DATAStatus(struct LINK *LINKtmp)
//{
   //struct DATA *DATAtmp;
   //int         i;
   //
   //LocateXY(1,6);
   //printf("block_mark=%d data_handle=%d  data_mark=%d  data_size=%d",
   //        (*LINKtmp).block_mark ,
   //        (*LINKtmp).data_handle,
   //        (*LINKtmp).data_mark,
   //        (*LINKtmp).data_size );
   //
   //DATAtmp=DATAPointer(LINKtmp);
   //LocateXY(1,10);
   //for(i=0;i<128;i++) printf("%.2x  ",(unsigned char)(*DATAtmp).mark[i]);
   //
   //LocateXY(1,18);
   //printf("data_handle=%d  useable=%d   ems_handle=%d   prev=%ld  next=%ld",
   //       (*DATAtmp).data_handle,
   //       (*DATAtmp).useable,
   //       (*DATAtmp).ems_handle,
   //       DATAtmp->prev,
   //       DATAtmp->next);
   //getch();
//}
