#include <dos.h>
#include <dir.h>
#include <stdio.h>
#include <string.h>
#include <bios.h>
#include <malloc.h>
#include <conio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <ctype.h>
#include <process.h>
#include <errno.h>
#include "we.h"
#include "tools.h"
#include "csf.h"

#define ON      1
#define OFF     0
#define COLOR   1
#define MONO    0

extern int KEY_STATUS;
extern int MONITOR;
int        BUSY=OFF;

char far *VideoType()
{
   union REGS reg1;

   reg1.h.ah=15;
   int86(0x10,&reg1,&reg1);                     /*  */
   if(reg1.h.al==7)
   {
      return((char far *)0xb0000000);
   }
   else                                         /* m */
   {
      return((char far *)0xb8000000);
   }
}


void ChineseSwitch(char mode)                   // E-^  C-
{
   union REGS regs;

   regs.x.ax =0x8c15;
   regs.h.bl =mode;
   int86(0x10,&regs,&regs);
}

//  void DrawBorder(x,y,x1,y1) int x,y,x1,y1;
//  {
//     int i;
//
//     ChineseSwitch('E');
//     LocateXY(x,y);     putchar(' ');   LocateXY(x+1,y);   putchar('');
//     LocateXY(x1,y);    putchar(' ');   LocateXY(x1-1,y);  putchar('');
//     LocateXY(x,y1);    putchar(' ');   LocateXY(x+1,y1);  putchar('');
//     LocateXY(x1,y1);   putchar(' ');   LocateXY(x1-1,y1); putchar('');
//
//     for(i=(x+2);i<(x1-1);i++) { LocateXY(i,y); putchar('');  }
//     for(i=(y+1);i<y1;i++)
//     {
//        LocateXY(x,i);    putchar(' ');
//        LocateXY(x+1,i);  putchar('');
//        LocateXY(x1,i);   putchar(' ');
//        LocateXY(x1-1,i); putchar('');
//     }
//     for(i=(x+2);i<(x1-1);i++) { LocateXY(i,y1); putchar('');  }
//     ChineseSwitch('C');
//  }


void ClrScr(int cl, int ch, int dl, int dh, int color)
{
   union REGS reg1;

   reg1.h.ah=7;              reg1.h.al=(dh-ch)+1;
   reg1.h.bh=color;          reg1.h.bl=0;
   reg1.h.ch=ch-1;           reg1.h.cl=cl-1;
   reg1.h.dh=dh-1;           reg1.h.dl=dl-1;
   int86(0x10,&reg1,&reg1);
}

// ------ driver(0='A' 1='B' 2='C') ------
// -------- P_ϺоO_igJ ---------
int ChkDiskWrite(int driver)
{
   union  REGS  regs;
   struct SREGS sregs;
   char         buffer[513];

   if(driver<0) return(0);
   if(driver>1)                                 // C ϺоLk CHECK
   {
      if(driver==CDROMdriver()) return(0);      // CD-ROM LkgJ
      return(1);
   }

   regs.h.ah = 0;                               // ]Ϻо
   regs.h.dl = driver;
   int86(0x13,&regs,&regs);

   // ----- ŪSwϰϸ ------
   regs.h.ah = 2;
   regs.h.al = 1;
   regs.h.cl = 1;
   regs.h.ch = 0;
   regs.h.dh = 1;
   regs.h.dl = driver;
   regs.x.bx = FP_OFF(buffer);
   sregs.es  = FP_SEG(buffer);
   int86x(0x13,&regs,&regs,&sregs);
   if(regs.h.ah == 0)                           // Disk ready
   {
      // ----- gJSwϰϸ ------
      regs.h.ah = 3;
      regs.h.al = 1;
      regs.h.cl = 1;
      regs.h.ch = 0;
      regs.h.dh = 1;
      regs.h.dl = driver;
      regs.x.bx = FP_OFF(buffer);
      sregs.es  = FP_SEG(buffer);
      int86x(0x13,&regs,&regs,&sregs);
      if(regs.h.ah==0) return(1);
   }
   return(0);
}

// ------ driver(0='A' 1='B' 2='C') ------
int ChkDisk(int driver)
{
   union  REGS  regs;
   struct SREGS sregs;
   char buffer[513];
   int  i;

   if(driver<0) return(0);
   if(driver>1)                                 // C ϺоLk CHECK
   {
      if(driver==CDROMdriver())                 // CD-ROM @ CHECK
      {
         if(!CDROMready(driver+'A')) return(0);
      }
      return(1);
   }

   regs.h.ah = 0;                               // ]Ϻо
   regs.h.dl = driver;
   int86(0x13,&regs,&regs);

   for(i=0;i<2;i++)                             // ŪSwϰϸ
   {
      regs.h.ah = 2;
      regs.h.al = 1;
      regs.h.cl = 1;
      regs.h.ch = 0;
      regs.h.dh = 1;
      regs.h.dl = driver;
      regs.x.bx = FP_OFF(buffer);
      sregs.es  = FP_SEG(buffer);
      int86x(0x13,&regs,&regs,&sregs);
      if(regs.h.ah == 0) return(1);             /* Disk ready !! */
      sleep(1);
   }
   return(0);
}

int ChkPrn()
{
   int   i;
   union REGS regs;

   for(i=0;i<3;i++)
   {
      regs.x.dx=0x00;
      regs.h.ah=0x02;
      int86(0x17,&regs,&regs);
      if(regs.h.ah==0x90) return(1);
      delay(55);
      BUSY=ON;
   }
   return(0);
}

int ChkPrnDelay(int ms)
{
   int   i;
   union REGS regs;

   for(i=0;i<3;i++)
   {
      regs.x.dx=0x00;
      regs.h.ah=0x02;
      int86(0x17,&regs,&regs);
      if(regs.h.ah==0x90) return(1);
      delay(ms);
      BUSY=ON;
   }
   return(0);
}

void SetCursor(int mode)
{
// union REGS regs;
//
// regs.h.ah =0x01;
// switch(mode)
// {
//    case 1  :  regs.h.ch =0x0c;               /*            W */
//               regs.h.cl =0x0e;               /*            U */
//               break;
//    case 0  :  regs.h.ch =0x2c;               /* bit5=hidn  W */
//               regs.h.cl =0x2e;               /*            U */
//               break;
//    default :  regs.h.ch =0x0a;               /*            W */
//               regs.h.cl =0x0e;               /*            U */
//               break;
// }
//
// int86(0x10,&regs,&regs);
}

int EraseSpace(char *ss)
{
   char *head,*tail;
   char *ts;

   head=ss;                                    /* Vrꪺ̫e */
   tail=ss+(strlen(ss)-1);                     /* Vrꪺ̫ */

   while(tail>=head)                           /* Mrꤧ᪺ť */
   {
     if(*tail==' ' || *tail==0x0a || *tail==0x0d)  *tail--='\0';  else  break;
   }

   while(*head!='\0')                          /* Mrꤧeť */
   {
     if(*head==' ')   head++;  else  break;
   }

   ts =ss;
   while(*head!='\0')  *ts++=*head++;
   *ts='\0';

   while(ts<=tail) *ts++='\0';                 /* ᪺rNULL */
   if(*ss=='\0') return(0); else return(1);
}

void ColorPutc(int x, int y, int ch)
{
   char *screen;

   screen  =VideoType();
   screen +=((y-1)*160+(x-1)*2);
   *screen     =(char)ch;
}

// ----- \|P_rO_SŸ,HSC (ColorPuts1|) ----
void ColorPuts(int x, int y, unsigned char *str, int color)
{
   static int clr;
   char       *screen;
   int        SPCFONT=OFF;
   int        CHINESE=OFF;

   if(y<1 || y>25) return;
   screen  =VideoType();
   screen +=((y-1)*160+(x-1)*2);

   while(*str!='\0')
   {
      //if(*str==0x0a) break;
      *screen     =*str;
      *(screen+1) =color;

      // ---------- Sr, NCର CYAN -----------
      if(y<23)
      {
         if(!CHINESE)
         {
            if(*str>=0xa1)
            {
               // ----------- DзǤrɤ~Bz ------------
               CHINESE=ON;
               if(!((*str>0xa3 && *str<0xc6) || (*str>0xc8 && *str<0xf9)))
               {
                  // ----------- SŸ SPCFONT ------------
                  if( (*str>=0xa1 && *str    <=0xa3)  ||
                      (*str==0xf9 && *(str+1)>=0xd6) )
                  {
                     clr=(color & 0xf0) | F_CYAN;       // @Ÿ
                     if((*str==0xa2 && *(str+1)>=0x71 && *(str+1)<=0xa7)  ||
                        (*str==0xf9 && *(str+1)>=0xdd && *(str+1)<=0xfd))
                     {
                        clr=(color & 0xf0) | F_MAGENTA; // Ÿ
                     }
                     SPCFONT=ON;
                  }
                  else
                  {
                     // ----------- SŸ SPCFSUPP -----------
                     if( (*str    >=0xc6 && *str    <=0xc8)  &&
                         (*(str+1)>=0xa1 && *(str+1)<=0xf1) )
                     {
                        clr=(color & 0xf0) | F_CYAN;
                        SPCFONT=ON;
                     }
                  }
                  // -----------------------------------------
                  if(SPCFONT)
                  {
                     if(*(str+1)!='\0')
                     {
                        *(screen+1)=*(screen+3)=clr;
                        str++;
                        screen +=2;
                        *screen =*str;
                     }
                     CHINESE=SPCFONT=OFF;
                     str++;
                     screen +=2;
                     continue;
                  }
               }
            }
         }
         else
         {
            CHINESE=OFF;
         }
      }
      screen +=2;
      str++;
   }
}


// ----- \ण|P_rO_SŸ (ColorPuts|) ----
void ColorPuts1(int x, int y, unsigned char *str, int color)
{
   char *screen;

   if(y<1 || y>25) return;
   screen  =VideoType();
   screen +=((y-1)*160+(x-1)*2);

   while(*str!='\0')
   {
      if(*str==0x0a) break;
      *(screen  )=*str;
      *(screen+1)=color;
      screen    +=2;
      str++;
   }
}

void ColorPutsAttrib(int x, int y, unsigned char *str, unsigned char color)
{
   char *screen;

   screen  =VideoType();
   screen +=((y-1)*160+(x-1)*2);

   while(*str!='\0')
   {
      *(screen+1)  =color;
      screen      +=2;
      str++;
   }
}

void ColorBgAttrib(int x, int y, unsigned char *str, unsigned char color)
{
   int  clr;
   char *screen;

   screen  =VideoType();
   screen +=((y-1)*160+(x-1)*2);
   clr     =(color & 0xf0);

   while(*str!='\0')
   {
      if(MONITOR!=COLOR)
      {
         if(color==0x00) *(screen+1)=0x07; else *(screen+1)=0x70;
      }
      else
      {
         *(screen+1)=(*(screen+1) & 0x0F)|clr;
      }
      screen     +=2;
      str++;
   }
}

void ColorFgAttrib(int x, int y, unsigned char *str, unsigned char color)
{
   int  clr;
   char *screen;

   screen =VideoType() + ((y-1)*160+(x-1)*2) + 1;
   clr    =(color & 0x0f);

   while(*str!='\0')
   {
      *screen =(*screen & 0xF0) | clr;
      screen     +=2;
      str++;
   }
}

void ColorFgAttribOR(int x, int y, unsigned char *str, unsigned char color)
{
   char *screen;

   screen  =VideoType()+ ((y-1)*160+(x-1)*2) + 1;

   while(*str!='\0')
   {
      *screen =*screen | color;
      screen +=2;
      str++;
   }
}


int GetAttrib(int x,int y)
{
   char *screen;

   screen  =VideoType();
   screen +=((y-1)*160+(x-1)*2);
   return(*(screen+1));
}

void LocateXY(int x, int y)
{
   union REGS regs;

   regs.h.dl = x-1;
   regs.h.dh = y-1;
   regs.h.bh = 0;
   regs.h.ah = 0x02;
   int86(0x10,&regs,&regs);
}

void MidStr(char *ts, char *ss, int pos, int len)
{
   if(strlen(ss)<pos)  { *ts='\0'; return; }
   ss +=(pos-1);
   while(*ss!='\0' && len)
   {
      *ts++=*ss++;
      len--;
   }
   *ts='\0';
}

// -------------- ׸ɪť ----------------
void MidStr1(char *ts, char *ss, int pos, int len)
{
   if(strlen(ss)<pos)  { while(len) { *ts++=' '; len--; } *ts='\0'; return; }
   ss +=(pos-1);
   while(len)
   {
      if(*ss!='\0') *ts++=*ss++; else *ts++=' ';
      len--;
   }
   *ts='\0';
}

// -------------- q pos B, N ss J ts --------------
void MidInsert(char *ts, char *ss, int pos)
{
   char str1[512],str2[256];

   pos--;
   MidStr1(str1,ts,1    ,pos);
   MidStr( str2,ts,pos+1,255);

   strcat(str1,ss);
   strcat(str1,str2);
   strcpy(ts,str1);
}

// --------------- ts פɫJ, return ---------------
void MidReplace(char *ts, char *ss, int pos)
{
   if(strlen(ts)<(pos+strlen(ss)-1)) return;
   ts +=(pos-1);
   while(*ss!='\0') *ts++=*ss++;
}

void MidDelete(char *ts, int pos, int len)
{
   char str1[512], str2[256];

   if(strlen(ts)<pos) return;
   MidStr(str1,ts,1,pos-1);
   MidStr(str2,ts,(pos+len),255);
   strcat(str1,str2);
   strcpy(ts,str1);
}

// --------------- ts פɫJ, ɪť ---------------
void MidReplace1(char *ts, char *ss, int pos)
{
   int i,len1,len2;

   len1=strlen(ts);
   len2=pos+strlen(ss)-1;
   if(len1<len2)
   {
      for(i=len1;i<len2;i++) { *(ts+i)=' '; }  *(ts+i)='\0';
   }
   ts +=(pos-1);
   while(*ss!='\0') *ts++=*ss++;
}

//  void StrChange(char *str,char *ss,char *ts)  /* N str rꤤ ss r H ts rN */
//  {
//     char *sp1,*ks;
//     char str1[100];
//
//     if((ks=strstr(str,ss))==NULL) return;
//     sp1=ks+strlen(ss);
//     *ks='\0';
//
//     strcpy(str1,str);
//     strcat(str1,ts);
//     strcat(str1,sp1);
//     strcpy(str,str1);
//  }


void StrUpr(unsigned char *ts)
{
   int cnt    =0;
   int CHINESE=OFF;

   while(*ts!='\0')
   {
      cnt++;
      if(CHINESE)  { CHINESE=OFF; ts++; continue; }
      if(*ts>=0x80)
      {
         CHINESE=ON;
         ts++;
      }
      else
      {
         if(*ts>='a' && *ts<='z') *ts=*ts-'a'+'A';
         CHINESE=OFF;
         ts++;
      }
   }
}

unsigned long Time()
{
   unsigned long far *TIME;

   TIME=(unsigned long far *)MK_FP(0x40,0x6c);
   return(*TIME);
}

void DrawBox(int x1,int y1,int x2,int y2)
{
   int x,y;

   if((x2-x1)%2) x2--;
   LocateXY(x1+1,y1);   printf("z");
   LocateXY(x2-3,y1);   printf("{");
   LocateXY(x1+1,y2);   printf("|");
   LocateXY(x2-3,y2);   printf("}");
   LocateXY(x1+3,y1);   for(x=x1+3;x<x2-3;x+=2) printf("w");
   LocateXY(x1+3,y2);   for(x=x1+3;x<x2-3;x+=2) printf("w");
   for(y=y1+1;y<y2;y++) { LocateXY(x1+1,y); printf("x"); }
   for(y=y1+1;y<y2;y++) { LocateXY(x2-3,y); printf("x"); }
}

void GetPath(char *pathname, char *fname)
{
   char driver[MAXDRIVE];
   char directory[MAXDIR];
   char str[81];

   fnsplit(fname,driver,directory,str,str);
   sprintf(pathname,"%s%s",driver,directory);
}

// ---------------------- o|[DɦW ----------------------
void GetPathName(char *pathname, char *fname)
{
   char driver[MAXDRIVE];
   char directory[MAXDIR];
   char filename[MAXFILE];
   char str[81];

   fnsplit(fname,driver,directory,filename,str);
   sprintf(str,"%s%s",driver,directory);
   sprintf(pathname,"%s%s",str,filename);
}

int GetFullFname(char *fname1,char *fname)
{
   int  old_driver,new_driver,i;
   char path[81];
   char cur_path[81];
   char name[81];
   char driver[MAXDRIVE];
   char directory[MAXDIR];
   char filename[MAXFILE];
   char extension[MAXEXT];

   fnsplit(fname,driver,directory,filename,extension);

   old_driver=getdisk();
   if(driver[0]!='\0')
   {
      new_driver=toupper(driver[0])-'A';
      if(new_driver>=0)
      {
         if(ChkDisk(new_driver)) setdisk(new_driver); else return(-1);
      }
      else
      {
         return(-1);
      }
   }

   if(directory[0]!='\0')
   {
      getcwd(cur_path,80);
      i=strlen(directory);
      if(i>1) directory[i-1]='\0';              // Dڥؿ, ̫@Ӧrw \
      if(chdir(directory)==-1) { setdisk(old_driver); return(-1); }
      getcwd(path,80);
      chdir(cur_path);
   }
   else
   {
      getcwd(path,80);
   }

   if(strlen(path)==3)
   {
      sprintf(fname1,"%s%s%s",path,filename,extension);
   }
   else
   {
      sprintf(fname1,"%s\\%s%s",path,filename,extension);
   }
   if(driver[0]!='\0') setdisk(old_driver);     // ɦWaϺоW

   if((i=open(fname1,O_RDONLY))==-1)            // ɮ׵Lk}
   {
      if(errno!=ENOENT) return(-1);             // Lk}ҭ],Oɮפsb
   }
   else
   {
      close(i);
   }
   StrUpr(fname1);
   return(0);
}

int  ChkFileExist(char *fname)
{
   char name[81];
   int  status;

   // -------- o㪺ɮצW --------
   // ------- P_ɮ׬O_r -------
   if(GetFullFname(name,fname)==-1) return(-1); // ~ : }ɮ׿~
   status=ChkIsText(name);
   if(status==0)   return(-2);                  // ~ : ɮפr
   if(status==-1)  return(0);                   // s}ɮ

   strcpy(fname,name);
   return(1);                                   // ɮפwsb

}

int ChkIsText(char *fname)
{
   int  file;
   char buf[513];
   int  len,i,status;

   if((file=open(fname,O_RDONLY | O_BINARY))==-1)  return(-1); // ɮ׵Lk}

   len=read(file,buf,128);
   for(i=0,status=1;i<len;i++)
   {
      if(buf[i]==0x00 || buf[i]==0x07) { status=0; break; }
   }
   close(file);
   return(status);
}

int StrTok(char *ts,char cmd[][256])
{
   int  cnt,sw;

   for(sw=0;sw<10;sw++) cmd[sw][0]='\0';

   sw =0;
   cnt=0;
   while(*ts!='\0')
   {
      if(*ts=='/') { cnt++; sw=0; } else { cmd[cnt][sw++]=*ts;  cmd[cnt][sw]='\0'; }
      ts++;
   }
   if(sw!=0) cnt++;
   return(cnt);
}

int SetDisk(char *driver)
{
   int new_driver;

   if(driver[0]!='\0')
   {
      new_driver=toupper(driver[0])-'A';
      if(new_driver>=0)
      {
         if(ChkDisk(new_driver)) setdisk(new_driver);  else  return(0);
      }
   }
   return(1);
}

//char Getch()
//{
//   int ch;
//
//   while(1)
//   {
//      if((ch=GetKey())==-1) continue;
//      if((ch & 0xff00)== 0) break;
//   }
//   return((char)ch);
//}

int GetKey()
{
   union REGS regs;
   int        ch;

   // --------------- oS䪬A ----------------
   regs.h.ah=0x02;
   int86(0x16,&regs,&regs);
   ch=regs.h.al & 0x0F;                         //  NUM,INSERT,SCROLL,CAPS

   // ---------------- rJҦ -----------------
   regs.h.ah=0x06;
   regs.h.dl=0xff;
   intdos(&regs,&regs);
   if((regs.x.flags & 0x40)) return(-1);        // Zero flag=1 ܵL

   KEY_STATUS=ch;
   if(regs.h.al!=0)                             // q
   {
       return((int)regs.h.al);
   }
   else                                         // \
   {
      regs.h.ah=0x06;
      regs.h.dl=0xff;
      intdos(&regs,&regs);
      ch=regs.h.al;
      return(ch<<8);
   }
}

void ColorPutsA(int y)
{
   char          *screen;
   unsigned char str[256],*ts;
   int           SPCFONT=OFF;
   int           CHINESE=OFF;
   int           i,clr;

   screen  =VideoType();
   screen +=(y-1)*160;
   for(i=0,str[80]='\0'; i<80; i++) { str[i]=*screen; screen +=2; }

   ts      =str;
   screen  =VideoType();
   screen +=(y-1)*160;

   while(*ts!='\0')
   {
      // ---------- Sr, NCର CYAN -----------
      if(!CHINESE)
      {
         if(*ts>=0xa1)
         {
            // ----------- DзǤrɤ~Bz ------------
            CHINESE=ON;
            if(!((*ts>0xa3 && *ts<0xc6) || (*ts>0xc8 && *ts<0xf9)))
            {
               // ----------- SŸ SPCFONT ------------
               if( (*ts>=0xa1 && *ts    <=0xa3)  ||
                   (*ts==0xf9 && *(ts+1)>=0xd6) )
               {
                  clr=F_CYAN;                        // @Ÿ
                  if((*ts==0xa2 && *(ts+1)>=0x71 && *(ts+1)<=0xa7)  ||
                     (*ts==0xf9 && *(ts+1)>=0xdd && *(ts+1)<=0xfd))
                  {
                     clr=F_MAGENTA;                  // Ÿ
                  }
                  SPCFONT=ON;
               }
               else
               {
                  // ----------- SŸ SPCFSUPP -----------
                  if( (*ts    >=0xc6 && *ts    <=0xc8)  &&
                      (*(ts+1)>=0xa1 && *(ts+1)<=0xf1) )
                  {
                     clr=F_CYAN;
                     SPCFONT=ON;
                  }
               }
               // -----------------------------------------
               if(SPCFONT)
               {
                  if(*(ts+1)!='\0')
                  {
                     if((*(screen+1)&0x07)==0x07) *(screen+1)=(*(screen+1) & 0xf0) | clr;
                     if((*(screen+3)&0x07)==0x07) *(screen+3)=(*(screen+3) & 0xf0) | clr;
                     ts++;
                     screen +=2;
                  }
                  CHINESE=SPCFONT=OFF;
                  ts++;
                  screen +=2;
                  continue;
               }
            }
         }
      }
      else
      {
         CHINESE=OFF;
      }
      screen +=2;
      ts++;
   }
}

// ---------------- NťY tab , ^Ǫ ----------------
int CompressSpace(char *target, char *source)
{
   int space=0,len=0,i;

   while(*source!='\0')
   {
      if(*source==' ')
      {
         if((++space)==TAB_SPACE) { *target++=0x09; len++;  space=0; }
      }
      else
      {
         for(i=0;i<space;i++) { *target++=' ';  len++; }
         *target++=*source;
         len++;
         space=0;
      }
      source++;
   }
   *target='\0';
   return(len);
}

// ---------------- N tab Y^ťի, ^Ǫ ----------------
int UnCompressSpace(char *target, char *source)
{
   int i,len=0;

   while(*source!='\0')
   {
      if(*source!=0x09)
      {
         *target++=*source;
         len++;
      }
      else
      {
         for(i=0;i<TAB_SPACE;i++) *target++=' ';
         len+=TAB_SPACE;
      }
      source++;
   }
   *target='\0';
   return(len);
}

int StrCmp(char *ts1,char *ts2)
{
    char str1[256],str2[256];
    int  len1,len2;

    len1=UnCompressSpace(str1,ts1);
    len2=UnCompressSpace(str2,ts2);
    if(len1!=len2) return(1);
    return(strcmp(str1,str2));
}

int ScanStr(int x,int y,char *p,int len, int color)
{
   int  i,ch,cnt=0;
   char str[80];

   *p='\0';
   for(i=0,str[len]='\0';i<len;i++) str[i]=' ';
   ColorPuts1(x,y,str,color);
   LocateXY(x,y);

   str[1]='\0';
   while(1)
   {
      if(bioskey(1)) ch=(bioskey(0) & 0xff); else continue;
      if(!ch || ch==0x09) continue;              // \  tab
      if(ch==13)          return(1);

      #ifndef CSF
         if(ch==27)       return(0);
      #endif

      if(ch==8)                                  // BackSpace
      {
         if(cnt!=0)
         {
            *(--p)='\0';
            cnt--;
            ColorPuts1(x+cnt,y," ",color);
         }
         LocateXY(x+cnt,y);
         continue;
      }
      else
      {
         if(cnt!=len)
         {
            *(p++)=str[0]=ch;
            *p    ='\0';
            ColorPuts1(x+cnt,y,str,color);
            cnt++;
         }
      }
      LocateXY(x+cnt,y);
   }
}

// -------- CD-ROM O_sb , YsbǦ^Ϻоs (0:A 1:B 2:3 ....) ---------
int CDROMexist()
{
   union REGS   regs;

   regs.x.ax =0x1500;
   int86(0x2F,&regs,&regs);

   if(regs.h.al==0xff) return(regs.x.cx); else return(0);
}

// --------------------------- CD-ROM @X --------------------------------
int CDROMamount()
{
   union REGS   regs;

   regs.x.ax =0x1500;
   int86(0x2F,&regs,&regs);

   if(regs.h.al!=0xff) return(0);
   return(regs.x.bx);
}


// ----------- CD-ROM ҦbϺоs (0:A 1:B 2:C 3:D 4:E .....) ------------
int CDROMdriver()
{
   union REGS   regs;

   regs.x.ax =0x1500;
   int86(0x2F,&regs,&regs);

   if(regs.h.al!=0xff) return(-1);
   return(regs.x.cx);
}

// --------------------------- DRIVER 'C' 'D' 'E' -----------------------------
int CDROMready(int driver)
{
   union  REGS  regs;
   struct SREGS sregs;
   char         buffer[2048];

   regs.x.ax = 0x1505;
   regs.x.dx = 0x00;
   regs.x.cx = toupper(driver)-'A';
   regs.x.bx = FP_OFF(&buffer);
   sregs.es  = FP_SEG(&buffer);

   int86x(0x2F,&regs,&regs,&sregs);

   if(regs.x.cflag==0) return(1); else return(0);
}

