#include <stdio.h>
#include <string.h>
#include "we.h"
#include "cursor.h"
#include "tools.h"

#define ON      	1
#define OFF     	0


extern struct UNDO_STRUCT       UNDO;
extern struct CTRL_STRUCT       CTRL;
extern struct POS_STRUCT        POS;
extern struct LINE_STRUCT       LINE;
extern struct MACRO_STRUCT      MACRO;
extern struct DISPLAY_STRUCT    DISPLAY;
extern struct BACKUP            *ACTIVE;
extern struct LINK              *now;
extern struct LINK              *head;
extern struct LINK              *tail;
extern struct LINK              *NEW;
extern char                     text[256];
extern char                     cmd_text[256];

// -------- ФW ---------
void Up()
{
   if(CTRL.COMMAND) CommandToggle();
   if(POS.NOWY==LINE.SCRY) return;

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;
   now=now->prev;
   NowdataToText(now);

   if(POS.SCRY==LINE.SCRY)
   {
      POS.NOWY--;
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   }
   else
   {
      POS.SCRY --;
      POS.NOWY --;
   }
}

// -------- ФU ---------
void Down()
{
   if(CTRL.COMMAND) CommandToggle();
   if(POS.NOWY==POS.MAXY)
   {
      if(POS.SCRY==LINE.SCRY1)          // ڳ̫@,]Où̫@
      {                                 // hݤW@,HɧT
         POS.SCRY--;
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
      return;
   }

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;
   now=now->next;
   NowdataToText(now);

   if(POS.SCRY==LINE.SCRY1)
   {
      POS.NOWY++;
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   }
   else
   {
      POS.SCRY ++;
      POS.NOWY ++;
   }
}

void Left()
{
   int scrx,nowx,marx;

   if(!CTRL.COMMAND)
   {
      scrx=POS.SCRX;       nowx=POS.NOWX;      marx=POS.MARX;
   }
   else
   {
      scrx=POS.CMD_SCRX;   nowx=POS.CMD_NOWX;  marx=POS.CMD_MARX;
   }

   if(nowx==1) return;
   if(scrx==1)
   {
      marx -=20;
      nowx--;
      scrx  =20;
      if(!CTRL.COMMAND)
      {
         POS.SCRX         =scrx;
         POS.NOWX         =nowx;
         POS.MARX         =marx;
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
      else
      {
         POS.CMD_SCRX     =scrx;
         POS.CMD_NOWX     =nowx;
         POS.CMD_MARX     =marx;
         CompareRedraw(LINE.COMMAND,1);
      }
   }
   else
   {
      nowx--;
      scrx--;
   }

   if(!CTRL.COMMAND)
   {
      POS.SCRX    =scrx;     POS.NOWX    =nowx;    POS.MARX    =marx;
   }
   else
   {
      POS.CMD_SCRX=scrx;     POS.CMD_NOWX=nowx;    POS.CMD_MARX=marx;
   }
}

void Right()
{
   int scrx,nowx,marx;

   if(!CTRL.COMMAND)
   {
      scrx=POS.SCRX;       nowx=POS.NOWX;      marx=POS.MARX;
   }
   else
   {
      scrx=POS.CMD_SCRX;   nowx=POS.CMD_NOWX;  marx=POS.CMD_MARX;
   }

   if(nowx==255) return;
   if(scrx==80)
   {
      marx +=20;
      nowx++;
      scrx  =61;
      if(!CTRL.COMMAND)
      {
         POS.SCRX         =scrx;
         POS.NOWX         =nowx;
         POS.MARX         =marx;
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
      else
      {
         POS.CMD_SCRX     =scrx;
         POS.CMD_NOWX     =nowx;
         POS.CMD_MARX     =marx;
         CompareRedraw(LINE.COMMAND,1);
      }
   }
   else
   {
      nowx++;
      scrx++;
   }

   if(!CTRL.COMMAND)
   {
      POS.SCRX    =scrx;     POS.NOWX    =nowx;    POS.MARX    =marx;
   }
   else
   {
      POS.CMD_SCRX=scrx;     POS.CMD_NOWX=nowx;    POS.CMD_MARX=marx;
   }
}

void Home()
{
   int  i;
   int  scrx,nowx,marx;

   if(!CTRL.COMMAND)
   {
      scrx=POS.SCRX;       nowx=POS.NOWX;      marx=POS.MARX;
   }
   else
   {
      scrx=POS.CMD_SCRX;   nowx=POS.CMD_NOWX;  marx=POS.CMD_MARX;
   }

   if(nowx==1)  return;

   if(!CTRL.COMMAND)
   {
      for(i=1;i<(strlen(text)    +1);i++) if(text[i-1]    !=' ') break;
   }
   else
   {
      for(i=1;i<(strlen(cmd_text)+1);i++) if(cmd_text[i-1]!=' ') break;
   }

   if(nowx<=i)                                  // 쥻檺Ĥ@Ӧr
   {
      nowx=1;
      scrx=1;
      if(marx)
      {
         marx=0;
         if(!CTRL.COMMAND)
         {
            POS.SCRX         =scrx;
            POS.NOWX         =nowx;
            POS.MARX         =marx;
            CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
         }
         else
         {
            POS.CMD_SCRX     =scrx;
            POS.CMD_NOWX     =nowx;
            POS.CMD_MARX     =marx;
            CompareRedraw(LINE.COMMAND,1);
         }
      }
   }
   else                                         // rꪺĤ@Ӧr
   {
      if(i>(marx) && i<=(marx+80))              // rĤ@Ӧr,bثeùϤ
      {
         nowx=i;
         scrx=i-marx;
      }
      else                                      // rĤ@Ӧr,bثeùϤ
      {
         if(i<=80)
         {
            marx =0;
            nowx =i;
            scrx =i;
         }
         else
         {
            marx =0;
            nowx =i;
            while(i>60) { marx +=20; i -=20; }
            scrx =i;
         }
         if(!CTRL.COMMAND)
         {
            POS.SCRX         =scrx;
            POS.NOWX         =nowx;
            POS.MARX         =marx;
            CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
         }
         else
         {
            POS.CMD_SCRX     =scrx;
            POS.CMD_NOWX     =nowx;
            POS.CMD_MARX     =marx;
            CompareRedraw(LINE.COMMAND,1);
         }
      }
   }

   if(!CTRL.COMMAND)
   {
      POS.SCRX    =scrx;     POS.NOWX    =nowx;    POS.MARX    =marx;
   }
   else
   {
      POS.CMD_SCRX=scrx;     POS.CMD_NOWX=nowx;    POS.CMD_MARX=marx;
   }
}

void End()
{
   int len;
   int  scrx,nowx,marx;

   if(!CTRL.COMMAND)
   {
      scrx=POS.SCRX;       nowx=POS.NOWX;      marx=POS.MARX;
   }
   else
   {
      scrx=POS.CMD_SCRX;   nowx=POS.CMD_NOWX;  marx=POS.CMD_MARX;
   }

   if(!CTRL.COMMAND) len=strlen(text);  else  len=strlen(cmd_text);

   if(len==255) len=254;

   nowx=(len+1);

   if((len-marx)>=80 || len<marx)
   {
      if(len<80)
      {
         marx =0;
         scrx =(len+1);
      }
      else
      {
         marx =0;
         while((len+1)>60) { marx +=20; len -=20; }
         scrx =(len+1);
      }
      if(!CTRL.COMMAND)
      {
         POS.SCRX         =scrx;
         POS.NOWX         =nowx;
         POS.MARX         =marx;
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      }
      else
      {
         POS.CMD_SCRX     =scrx;
         POS.CMD_NOWX     =nowx;
         POS.CMD_MARX     =marx;
         CompareRedraw(LINE.COMMAND,1);
      }
   }
   else
   {
      scrx=(len+1)-marx;
   }

   if(!CTRL.COMMAND)
   {
      POS.SCRX    =scrx;     POS.NOWX    =nowx;    POS.MARX    =marx;
   }
   else
   {
      POS.CMD_SCRX=scrx;     POS.CMD_NOWX=nowx;    POS.CMD_MARX=marx;
   }
}


void Pgup()
{
   int i;

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;

   if(POS.NOWY==POS.SCRY)                               // , ^Ĥ@
   {
      POS.NOWY=1;
      POS.SCRY=1;
      now=head;
      NowdataToText(now);
      return;
   }

   if((LINE.SCRY1-LINE.SCRY+1)>(POS.NOWY-POS.SCRY))     // @
   {
      for(i=1,now=head;i<POS.SCRY;i++) now=now->next;
      NowdataToText(now);
      POS.NOWY=POS.SCRY;
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   }
   else
   {
      for(i=0;i<(LINE.SCRY1-LINE.SCRY+1);i++) now=now->prev;
      NowdataToText(now);
      POS.NOWY -=(LINE.SCRY1-LINE.SCRY+1);
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   }
}

void Pgdn()
{
   int i;

   if((POS.NOWY-POS.SCRY+1)<=POS.MAXY &&
      (POS.NOWY-POS.SCRY+(LINE.SCRY1-LINE.SCRY+1))>=POS.MAXY) return;

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;

   if((POS.NOWY+(LINE.SCRY1-LINE.SCRY+1))>POS.MAXY)     // @
   {
      POS.NOWY=POS.MAXY;                                // ̫@
      POS.SCRY=(LINE.SCRY1-LINE.SCRY);
      now=tail;

      NowdataToText(now);
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   }
   else
   {
      for(i=0;i<(LINE.SCRY1-LINE.SCRY+1);i++) now=now->next;

      NowdataToText(now);

      POS.NOWY +=(LINE.SCRY1-LINE.SCRY+1);
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   }
}

void Top()
{
   if(CTRL.COMMAND) CommandToggle();
   if(POS.NOWY==1) return;

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;
   now=head;
   NowdataToText(now);

   if(POS.NOWY!=POS.SCRY)
   {
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   }
   POS.NOWY =1;
   POS.SCRY =1;
}

void Bottom()
{
   int i;

   if(CTRL.COMMAND) CommandToggle();

   if(POS.NOWY==POS.MAXY) return;
   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=tail;
   NowdataToText(now);

   if((POS.NOWY-POS.SCRY+1)<=POS.MAXY && (POS.NOWY-POS.SCRY+21)>=POS.MAXY)
   {
      for(i=POS.NOWY;i<POS.MAXY;i++) POS.SCRY++;
      POS.NOWY =POS.MAXY;
   }
   else
   {
      POS.NOWY =POS.MAXY;
      POS.SCRY =LINE.SCRY1-1;
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   }
}

void TopEdge()
{
   int i,scry;

   if(CTRL.COMMAND) CommandToggle();
   if(POS.SCRY==1) return;

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;

   scry=POS.SCRY;
   for(i=1;i<scry;i++)
   {
      now=now->prev;
      POS.SCRY--;
      POS.NOWY--;
   }
   NowdataToText(now);
}

void BottomEdge()
{
   int i,scry,posy1;

   if(CTRL.COMMAND) CommandToggle();
   if(POS.NOWY==POS.MAXY)   return;             // wOڳ̫@
   if(POS.SCRY==LINE.SCRY1) return;             // wOù̫@

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;

   posy1=POS.NOWY + (LINE.SCRY1-POS.SCRY) ;     // ù̫@檺ڦ

   if(POS.MAXY<posy1)                           // ̫@bثeù
   {
      for(i=POS.NOWY;i<POS.MAXY;i++)
      {
         now=now->next;
         POS.SCRY++;
         POS.NOWY++;
      }
   }
   else
   {
      scry=POS.SCRY;
      for(i=scry;i<LINE.SCRY1;i++)
      {
         now=now->next;
         POS.SCRY++;
         POS.NOWY++;
      }
   }
   NowdataToText(now);
}

void Tab()
{
   int skip;
   int scrx,nowx,marx;

   if(!CTRL.COMMAND)
   {
      scrx=POS.SCRX;       nowx=POS.NOWX;      marx=POS.MARX;
   }
   else
   {
      scrx=POS.CMD_SCRX;   nowx=POS.CMD_NOWX;  marx=POS.CMD_MARX;
   }

   if((nowx+TAB_SPACE)>255) return;

   skip=TAB_SPACE-((nowx-1)%TAB_SPACE);
   while(skip--)                                // C TAB VkKŮ
   {
      if(scrx==80)
      {
         marx +=20;
         nowx++;
         scrx  =61;
         if(!CTRL.COMMAND)
         {
            POS.SCRX         =scrx;
            POS.NOWX         =nowx;
            POS.MARX         =marx;
            CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
         }
         else
         {
            POS.CMD_SCRX     =scrx;
            POS.CMD_NOWX     =nowx;
            POS.CMD_MARX     =marx;
            CompareRedraw(LINE.COMMAND,1);
         }
      }
      else
      {
         nowx++;
         scrx++;
      }
   }

   if(!CTRL.COMMAND)
   {
      POS.SCRX    =scrx;     POS.NOWX    =nowx;    POS.MARX    =marx;
   }
   else
   {
      POS.CMD_SCRX=scrx;     POS.CMD_NOWX=nowx;    POS.CMD_MARX=marx;
   }
}

void BackTab()
{
   int skip;
   int scrx,nowx,marx;

   if(!CTRL.COMMAND)
   {
      scrx=POS.SCRX;       nowx=POS.NOWX;      marx=POS.MARX;
   }
   else
   {
      scrx=POS.CMD_SCRX;   nowx=POS.CMD_NOWX;  marx=POS.CMD_MARX;
   }

   if(nowx==1) return;

   if( (skip=(nowx-1)%TAB_SPACE)==0 ) skip=TAB_SPACE;
   while(skip--)                                // C TAB VKŮ
   {
      if(scrx==1)
      {
         marx -=20;
         nowx--;
         scrx  =20;
         if(!CTRL.COMMAND)
         {
            POS.SCRX         =scrx;
            POS.NOWX         =nowx;
            POS.MARX         =marx;
            CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
         }
         else
         {
            POS.CMD_SCRX     =scrx;
            POS.CMD_NOWX     =nowx;
            POS.CMD_MARX     =marx;
            CompareRedraw(LINE.COMMAND,1);
         }
      }
      else
      {
         nowx--;
         scrx--;
      }
   }

   if(!CTRL.COMMAND)
   {
      POS.SCRX    =scrx;     POS.NOWX    =nowx;    POS.MARX    =marx;
   }
   else
   {
      POS.CMD_SCRX=scrx;     POS.CMD_NOWX=nowx;    POS.CMD_MARX=marx;
   }
}
