#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <dir.h>
#include <io.h>
#include <fcntl.h>
#include "we.h"
#include "tools.h"
#include "dir.h"
#include "macro.h"
#include "mark.h"
#include "cursor.h"
#include "box.h"
#include "undo.h"

#define ON      1
#define OFF     0

extern struct POS_STRUCT     POS;
extern struct LINE_STRUCT    LINE;
extern struct CTRL_STRUCT    CTRL;
extern struct UNDO_STRUCT    UNDO;
extern struct DISPLAY_STRUCT DISPLAY;
extern struct MACRO_STRUCT   MACRO;
extern struct SET_STRUCT     SET;


extern char                  FNAME[80];
extern int                   fprint;


// ---------------------------------------------------
// -1   : }ɥ, ɮפsb
//  0   : 榨\
// else : Ǧ^楢Ѫ
// ---------------------------------------------------
int Macro(char *fname)
{
   int  fhandle;
   int  i,cnt,sw;
   int  line_cnt;
   int  ERROR=OFF;
   int  EXIT =OFF;
   long pos;
   char *ts;
   char data[3],str[256],cmd[10][81];

   // -------- o㪺ɮצW, P_ɮ׬O_r  --------
   if(GetFullFname(str,fname)==-1)
   {
      DisplayMessage("~ : }ɮ׿~",ON);       return(-1);
   }
   sw=ChkIsText(str);
   if(sw== 0)      { DisplayMessage("~ : ɮפr",ON); return(-1); }
   if(sw==-1)      { DisplayMessage("~ : ɤsb"    ,ON); return(-1); }

   fhandle=open(str,O_RDWR | O_TEXT);
   if(fhandle==-1) { DisplayMessage("~ : }ɮ׿~"    ,ON); return(-1); }

   MACRO.debug=OFF;
   MACRO.loop =OFF;
   // ------------------------ ɮŪJ -------------------------
   line_cnt=0;
   while(!EXIT)
   {
      // ---------------- ŪJ@ -----------------------------
      ts =str;
      *ts='\0';
      while(1)
      {
         if(read(fhandle,data,1)==0)        { EXIT=ON; break; }
         if(data[0]==0x0a || data[0]==0x0d) { break;  }
         if(*ts==0x09) { for(i=0;i<TAB_SPACE;i++) *ts++=' ';  } else { *ts++=data[0]; }
         *ts='\0';
      }

      pos=tell(fhandle);
      line_cnt++;

      // ----------------- '#' H ---------------------
      for(i=0;i<strlen(str);i++)  { if(str[i]=='#') { str[i]='\0'; break; } }

      if(!EraseSpace(str)) { continue;         }
      if(str[0]!='[')      { ERROR=ON;  break; }

      // ---------------- P_ '[]' O_ --------------------
      for(i=0,cnt=0; i<strlen(str); i++)
      {
         if(str[i]=='[') { cnt++; if(cnt>1) { ERROR=ON; break; } }
         if(str[i]==']') { cnt--; if(cnt<0) { ERROR=ON; break; } }
      }

      cnt=0;
      if((ts=strtok(str,"[]"))!=NULL)     { if(strlen(ts)<80) strcpy(cmd[cnt++],ts); }
      while(ts!=NULL)
      {
         if((ts=strtok(NULL,"[]"))!=NULL) { if(strlen(ts)<80) strcpy(cmd[cnt++],ts); }
      }

      for(i=0;i<cnt && !ERROR;i++)
      {
         //LocateXY(1,25);  printf("cmd[%d]='%s'",i,cmd[i]);  getch();
         EraseSpace(cmd[i]);
         if(!MacroRun(cmd[i],pos,fhandle)) ERROR=ON;

         // --------------- ϥΪ̫ 'Esc' _ ----------------
         if(MACRO.debug==OFF && (sw=GetKey())!=-1)
         {
            if(sw==0x001b) { EXIT=ON; break; }
         }

         // ------------------ iJ MACRO DEBUG Ҧ -------------------
         if(!ERROR && MACRO.debug)
         {
            if(DISPLAY.REDISPLAY)  Redraw(DISPLAY.SCRY,DISPLAY.CNT);
            LightLine();
            StatusXY();
            sprintf(str," [%d] , O [%s] 槹 !! (Press a Key)",line_cnt,cmd[i]); str[79]='\0';
            DisplayMessageNoBeep(str);
            LocateXY(strlen(str)+1,LINE.MESSAGE);

            // ----------------  'Esc' _  --------------------
            if(Getch()==0x1b) { EXIT=ON; break; }
         }
      }
      if(ERROR==ON) break;
   }
   close(fhandle);

   if(ERROR) return(line_cnt); else return(0);          // bĴXX
}

// ---------------------------------------------------
// -1   : r꦳~
//  0   : 榨\
// else : Ǧ^楢Ѫ
// ---------------------------------------------------
int MacroStr(char *macro)
{
   int  i,cnt;
   char *ts;
   char str[256],str1[256],cmd[256];

   MACRO.debug=OFF;
   MACRO.loop =OFF;

   // ----------------- '#' H ---------------------
   strcpy(str,macro);
   for(i=0;i<strlen(str);i++)  { if(str[i]=='#') { str[i]='\0'; break; } }
   if(!EraseSpace(str)) return(0);
   if(str[0]!='[')      return(-1);

   // ---------------- P_ '[]' O_ --------------------
   for(i=0,cnt=0; i<strlen(str); i++)
   {
      if(str[i]=='[') { cnt++;  if(cnt>1) return(-1); }
      if(str[i]==']') { cnt--;  if(cnt<0) return(-1); }
   }

   // --------------------- 楨O ---------------------
   if((ts=strtok(str,"[]"))!=NULL)
   {
      strcpy(cmd,ts);
      EraseSpace(cmd);
      if(!MacroRun(cmd,0,0)) return(-1);
   }

   while(ts!=NULL)
   {
      if((ts=strtok(NULL,"[]"))!=NULL)
      {
         strcpy(cmd,ts);
         EraseSpace(cmd);
         if(!MacroRun(cmd,0,0)) return(-1);
         // ------------------ iJ MACRO DEBUG Ҧ -------------------
         if(MACRO.debug)
         {
            if(DISPLAY.REDISPLAY)  Redraw(DISPLAY.SCRY,DISPLAY.CNT);
            LightLine();
            StatusXY();
            sprintf(str1,"O [%s] 槹 !! (Press a Key)",cmd); str[79]='\0';
            DisplayMessageNoBeep(str1);
            LocateXY(strlen(str1)+1,LINE.MESSAGE);

            // ----------------  'Esc' _  --------------------
            if(Getch()==0x1b)  break;
         }
      }
   }
   return(0);
}

// ------------------------- 0:  1:\ -------------------------
int MacroRun(char *command, long pos, int fhandle)
{
   #include  "macro.cmd"                        // wqF macro[]

   long line_no;
   int  cnt=0,sw,i,scrx;
   char delimiter[3];
   char cmd[6][81];
   char str[81];
   char *ts;

   if(strlen(command)>80) return(0); else ts=command;

   // --------  [Column 20][Right 10][Fill string] .... --------
   for(i=0;i<5;i++) cmd[i][0]='\0';
   i=cnt=0;
   while(*ts!='\0')
   {
      if(*ts==' ')
      {
         if(cmd[cnt][0]!='\0')
         {
            if(cnt==0)
            {
               if(stricmp(cmd[0],"CALC")==0 || stricmp(cmd[0],"RUN")==0    ||
                  stricmp(cmd[0],"FILL")==0 || stricmp(cmd[0],"STRING")==0 ||
                  stricmp(cmd[0],"MESSAGE")==0)
               {
                  strcpy(cmd[1],ts);
                  cnt=2;
                  i  =0;
                  break;
               }
            }
            if((++cnt)>5) break; else i=0;
         }
      }
      else
      {
          cmd[cnt][i++]=*ts;
          cmd[cnt][i]  ='\0';
      }
      ts++;
   }
   if(i!=0) cnt++;

   //for(i=0;i<cnt;i++)
   //{
   //  LocateXY(1,25); printf("cmd[%d]='%s'    ",i,cmd[i]);  getch();
   //}

   sw=0;
   while(macro[sw][0]!='\0')
   {
      if(stricmp(macro[sw],cmd[0])==0) break;
      sw++;
   }
   if(macro[sw][0]=='\0') return(0);             // OSo{

   switch(sw)
   {
       case  0  : //  BackTab
             BackTab();
             break;
       case  1  : //  BeginLine
             Home();
             break;
       case  2  : //  BeginMark
             MarkBegin();
             break;
       case  3  : //  BeginWord
             BeginWord();
             break;
       case  4  : //  BottomEdge
             BottomEdge();
             break;
       case  5  : //  Bottom
             Bottom();
             break;
       case  6  : //  Calc
             if(cnt==2)
             {
                sprintf(str,"T : pȬ (%.2f)   Ctrl-2 iNpȱaX!!",Calc(cmd[1]));
                DisplayMessage(str,ON);
             }
             break;
       case  7  : //  CommandToggle
             CommandToggle();
             break;
       case  8  : //  CopyFromCommand
             if(!CTRL.COMMAND) { CopyFromCommand(); break; }
             CommandToggle();
             CopyFromCommand();
             CommandToggle();
             break;
       case  9  : //  CopyMark
             MarkCopy();
             break;
       case  10 : //  CopyToCommand
             if(!CTRL.COMMAND) { CopyToCommand(); break; }
             CommandToggle();
             CopyToCommand();
             CommandToggle();
             break;
       case  11 : //  CursorCommand
             CursorCommand();
             break;
       case  12 : //  DeleteChar
             if(cnt==1) DeleteChar();
             if(cnt==2)
             {
                for(i=0;i<atoi(cmd[1]) && i<256;i++) DeleteChar();
             }
             break;
       case  13 : //  DeleteLine
             if(cnt==1) DeleteLine(POS.NOWY, POS.NOWY);
             if(cnt==2)
             {
                sw=POS.NOWY-1;
                DeleteLine(POS.NOWY, POS.NOWY);
                for(i=0;i<(atoi(cmd[1])-1) && POS.NOWY!=sw;i++) DeleteLine(POS.NOWY, POS.NOWY);
             }
             break;
       case  14 : //  DeleteMark
             MarkDelete();
             break;
       case  15 : //  Delay
             #ifndef CSF
                if(cnt==2)
                {
                   if((sw=atoi(cmd[1]))==0) sw=1 ;
                   if(sw>60)                sw=60;
                   for(i=sw; i>=0; i--)
                   {
                       sprintf(str," Delay : %.2d ",i);
                       ColorPuts1(65,LINE.MESSAGE,str,F_MAGENTA|F_INTENSE);
                       sleep(1);
                    }
                    ColorPuts1(65,LINE.MESSAGE,"                  ",0x07);
                }
             #endif
             break;
       case  16 : //  Dir
             #ifndef CSF
                if(cnt==1) Dir("."); else  Dir(cmd[1]);
             #endif
             break;
       case  17 : //  Dos
             #ifndef CSF
               Dos("");
             #endif
             break;
       case  18 : //  Down
             if(cnt==1) Down();
             if(cnt==2)
             {
                line_no=POS.NOWY+atol(cmd[1]);
                if(line_no>0) sprintf(str,"%ld",line_no); else strcpy(str,"1");
                Line(str);
             }
             break;
       case  19 : //  Edit
             #ifndef CSF
                if(cnt==1) break;
                for(i=1; i<cnt; i++)
                {
                   if(Edit(cmd[i])==-2) break;
                   if(MACRO.debug==OFF && DISPLAY.REDISPLAY)
                   {
                      Redraw(DISPLAY.SCRY,DISPLAY.CNT);
                      LightLine();
                      StatusXY();
                   }
                }
             #endif
             break;
       case  20 : //  EndLine
             End();
             break;
       case  21 : //  EndMark
             MarkEnd();
             break;
       case  22 : //  EndWord
             EndWord();
             break;
       case  23 : //  EraseBeginLine
             break;
       case  24 : //  EraseEndLine
             EraseEndLine();
             break;
       case  25 : //  Message
             if(cnt==1) DisplayMessage(" ",OFF);
             if(cnt==2) { EraseSpace(cmd[1]); DisplayMessage(cmd[1],ON); }
             break;
       case  26 : //  Execute
             #ifndef CSF
                if(strncmp(FNAME,".DIR",4)==0 && !CTRL.COMMAND) DirEnterContinue(); else Execute();
             #else
                if(strncmp(FNAME,".DIR",4)!=0) Execute();
             #endif
             break;
       case  27 : //  Fill
             if(cnt==2) MarkFill(cmd[1]);
             if(cnt==1) MarkFill(NULL);
             break;
       case  28 : //
             break;
       case  29 : //
             break;
       case  30 : //  InsertLine
             InsertLine();
             break;
       case  31 : //  InsertMode
             if(!CTRL.INSERT) InsertToggle();
             break;
       case  32 : //  Join
             Join();
             break;
       case  33 : //  Left
             if(cnt==1) Left();
             if(cnt==2)
             {
                for(i=0;i<atoi(cmd[1]);i++) { Left(); if(POS.NOWX==1) break; }
             }
             break;
       case  34 : //  MarkBlock
             MarkBlock();
             break;
       case  35 : //  MarkChar
             break;
       case  36 : //  MarkLine
             MarkLine();
             break;
       case  37 : //  MoveMark
             MarkMove();
             break;
       case  38 : //  NextFile
             NextFile();
             break;
       case  39 : //  OverlayBlock
             MarkOverlay();
             break;
       case  40 : //  PageDown
             Pgdn();
             break;
       case  41 : //  PageUp
             Pgup();
             break;
       case  42 : //  PopMark
             MarkPop();
             break;
       case  43 : //  PrintMark
             #ifndef CSF
                if(fprint!=-1) break;
                PrintMark();
             #endif
             break;
       case  44 : //  PushMark
             MarkPush();
             break;
       case  45 : //  Quit
             if(cnt==1) Quit();
             #ifndef CSF
                EraseSpace(cmd[1]);
                if(cnt==2 && stricmp(cmd[1],"ALL")==0) QuitAll();
             #endif
             break;
       case  46 : //  Redraw
             Refresh();
             break;
       case  47 : //  Right
             if(cnt==1) Right();
             if(cnt==2)
             {
                for(i=0;i<atoi(cmd[1]);i++) { Right(); if(POS.NOWX==255) break; }
             }
             break;
       case  48 : //  BackSpace
             Left();
             DeleteChar();
             break;
       case  49 : //  Run
             #ifndef CSF
                if(cnt==2) Dos(cmd[1]);
             #endif
             break;
       case  50 : //  ShiftLeft
             if(cnt==1) ShiftLeft(0);
             if(cnt==2)
             {
                for(i=0;i<atoi(cmd[1]);i++) ShiftLeft(0);
             }
             break;
       case  51 : //  ShiftRight
             if(cnt==1) ShiftRight(0);
             if(cnt==2)
             {
                for(i=0;i<atoi(cmd[1]);i++) ShiftRight(0);
             }
             break;
       case  52 : //  Split
             Slipt();
             break;
       case  53 : //  TabWord
             TabWord();
             break;
       case  54 : //  Tab
             Tab();
             break;
       case  55 : //  TopEdge
             TopEdge();
             break;
       case  56 : //  Top
             Top();
             break;
       case  57 : //  UnMark
             UnMark();
             break;
       case  58 : //  Up
             if(cnt==1) Up();
             if(cnt==2)
             {
                line_no=POS.NOWY-atol(cmd[1]);
                if(line_no>0) sprintf(str,"%ld",line_no); else strcpy(str,"1");
                Line(str);
             }
             break;
       case  59 : //  Enter
             if(CTRL.COMMAND) { Execute(); break; }
             if(strncmp(FNAME,".DIR",4)!=0) InsertLine();
             #ifndef CSF
                if(strncmp(FNAME,".DIR",4)==0) DirEnter();
             #endif
             break;
       case  60 : // STRING
             if(cnt==2)
             {
                EraseSpace(cmd[1]);
                ts=cmd[1];
                while(*ts!='\0') { KeyNormal((int)(*ts)); ts++; }
             }
             break;
       case  61 : // ASCII
             if(cnt==2)
             {
                EraseSpace(cmd[1]);
                sw=atoi(cmd[1]);
                if(sw<255 && sw!=0x1a && sw!=0xa) KeyNormal(sw);
             }
             break;
       case  62 : //  Save
             if(cnt==2) Save(cmd[1]);
             if(cnt==1) Save(FNAME);
             break;
       case  63 : //  File
             if(cnt==2) { if(Save(cmd[1])==1) Quit(); }
             if(cnt==1) { if(Save(FNAME) ==1) Quit(); }
             break;
       case  64 : //  Line
             if(cnt==2)
             {
                EraseSpace(cmd[1]);
                Line(cmd[1]);
             }
             break;
       case  65 : //  Cd
             #ifndef CSF
                if(cnt==2)
                {
                   EraseSpace(cmd[1]);
                   chdir(cmd[1]);
                }
             #endif
             break;
       case  66 : //  Del
             #ifndef CSF
                if(cnt==2)
                {
                   EraseSpace(cmd[1]);
                   unlink(cmd[1]);
                }
             #endif
             break;
       case  67 : //  Number
             if(cnt==3)
             {
                EraseSpace(cmd[1]);
                EraseSpace(cmd[2]);
                Number(cmd[1],cmd[2]);
             }
             break;
       case  68 : //  Sort
             if(cnt==2)
             {
                EraseSpace(cmd[1]);
                if(strcmp(cmd[1],"+" )==0) MarkSort(1);  // W, jpg@
                if(strcmp(cmd[1],"-" )==0) MarkSort(2);  // , jpg@
                if(strcmp(cmd[1],"+=")==0) MarkSort(3);  // W, jpg@
                if(strcmp(cmd[1],"-=")==0) MarkSort(4);  // , jpg@
             }
             break;
       case  69 : //  Words
             Words();
             break;
       case  70 : //  Name
             #ifndef CSF
                if(cnt==2 && GetFullFname(str,cmd[1])!=-1)
                {
                   strcpy(FNAME,str);
                   CTRL.MODIFY=ON;
                }
             #endif
             break;
       case  71 : //  DebugOn
             #ifndef CSF
                MACRO.debug=ON;
             #endif
             break;
       case  72 : //  DebugOff
             #ifndef CSF
                MACRO.debug=OFF;
                DisplayMessage(" ",OFF);
             #endif
             break;
       case  73 : //  UpperCase
             UpperCase();
             break;
       case  74 : //  LowerCase
             LowerCase();
             break;
       case  75 : //  BeginLoop
             #ifndef CSF
                if(fhandle!=0)
                {
                   if(cnt==2 && MACRO.loop==OFF)
                   {
                      MACRO.loop      =ON;
                      MACRO.loop_pos  =pos;
                      MACRO.loop_times=atoi(cmd[1]);
                      if(MACRO.loop_times<=0) MACRO.loop_times=1;
                   }
                }
             #endif
             break;
       case  76 : //  EndLoop
             #ifndef CSF
                if(fhandle!=0)
                {
                   if(MACRO.loop)
                   {
                      if(MACRO.loop_times==1) { MACRO.loop=OFF; break; }
                      MACRO.loop_times--;
                      lseek(fhandle,MACRO.loop_pos,SEEK_SET);
                   }
                }
             #endif
             break;
       case  77 : //  WaitKey
             #ifndef CSF
                ColorPuts1(63,LINE.MESSAGE,"Ы@~",F_MAGENTA|F_INTENSE);
                LocateXY(78,LINE.MESSAGE);
                Getch();
                ColorPuts1(63,LINE.MESSAGE,"                  ",0x07);
             #endif
             break;
       case  78 : //  Column
             if(cnt==2)
             {
                if((sw=atoi(cmd[1]))<=0) break;
                Column(sw);
             }
             break;
       case  79 : //  ClearLine (F5)
             ClearLine();
             break;
       case  80 : //  ReplaceMode
             if(CTRL.INSERT)  InsertToggle();
             break;
       case  81 : //  AlignLeft   V勵
             MarkAlign(2);
             break;
       case  82 : //  AlignRight  Vk勵
             MarkAlign(3);
             break;
       case  83 : //  AlignCenter V勵
             MarkAlign(4);
             break;
       case  84 : //  BackTabWord
             BackTabWord();
             break;
       case  85 : //  UndoLine Shift-f4
             UndoLine();
             break;
       case  86 : //  Table    Alt-Tab
             Table();
             break;
       case  87 : //  Symbol   Ctrl-Tab
             Symbol();
             break;
       case  88 : //  InsertMode
             InsertToggle();
             break;
       case  89 : //  MarkWord
             MarkWord();
             break;
       case  90 : //  Grid
             if(cnt==5) BoxGrid(cmd[1],cmd[2],cmd[3],cmd[4]);
             break;
       case  91 : //  Message
             if(cnt==1) DisplayMessage(" ",OFF);
             if(cnt==2) { EraseSpace(cmd[1]); DisplayMessage(cmd[1],ON); }
             break;
       case  92 : //  Beep
             if(cnt==1) { sound(1600);  delay(200);  nosound(); }
             break;
       case  93 : //  Sum
             if(CTRL.MARK)
             {
                sprintf(str,"T : pȬ (%.2f)",MarkSum());
                DisplayMessage(str,ON);
             }
       case  94 : //  Result
             Result();
             break;
       case  95 : //  Arrange
             Arrange();
             break;
       case  96 : //  Insert
             #ifndef CSF
                if(cnt==2) {  EraseSpace(cmd[1]); Insert(cmd[1]);  }
             #endif
             break;
       case  97 : //  Print
             #ifndef CSF
                if(fprint!=-1) break;
                Print();
             #endif
             break;
       case  98 : //  Phrase
             Phrase();
             break;
       case  99 : //  MarkReverse
             MarkReverse();
             break;
       case 100 : //  RepeatDown   Ctrl-
            CursorCommand();
            CommandRepeat(0);
            break;
       case 101 : //  RepeatUp     Ctrl-
            CursorCommand();
            CommandRepeat(1);
            break;
       case 102 : //  KeyLock      Alt-K
            #ifndef CSF
               CTRL.MESSAGE=ON;
               RollUp( 1, 1, LINE.MESSAGE, 80, LINE.MESSAGE, 0x07);
               CTRL.KEYLOCK=1-CTRL.KEYLOCK;
               if(CTRL.KEYLOCK)
               {
                  ColorPuts1(72,25," KEYLOCK ",B_LIGHTGRAY|F_RED);
               }
            #endif
            break;
       case 103 : //  Nothing
            break;
       case 104 : //  } .UNDO   Ctrl-U
            #ifndef CSF
               UndoOpen();
            #endif
            break;
       case 105 : //  VW     Ctrl-
            sw=CTRL.COMMAND;
            if(sw) CommandToggle();
            LineExchange(1);
            Up();
            if(sw) CommandToggle();
            break;
       case 106 : //  VU     Ctrl-
            sw=CTRL.COMMAND;
            if(sw) CommandToggle();
            LineExchange(2);
            Down();
            if(sw) CommandToggle();
            break;
       case 107 : //  CursorEdit
            if(CTRL.COMMAND) { CommandToggle(); }
            break;
       case 108 : //  MarkInput
            MarkInput(0);
            break;
       case 109 : //  BoxInput
            BoxInput();
            break;
       case 110 : //  MarkExchange (Alt-C)
            MarkExchange(0x08, 0x2e00);
            break;
       case 111 : //  OpenCursorFile
            OpenCursorFile();
            break;
   }
   return(1);
}

// ------------------------- 0:  1:\ -------------------------
int MacroID(char *cmd)
{
   #include  "macro.cmd"                        // wqF macro[]
   int  i,sw=0;
   char str[255];

   // --------------- קK [Left 20] Q~yk ---------------
   strcpy(str,cmd);
   EraseSpace(str);
   for(i=0;i<strlen(str);i++) { if(str[i]==' ') { str[i]='\0'; break; } }

   while(macro[sw][0]!='\0')
   {
      if(stricmp(macro[sw],str)==0) break; else sw++;
   }
   if(macro[sw][0]!='\0') return(sw); else return(-1);  // OSo{
}
