#define COLOR           1
#define MONO            0
#define TAB_SPACE		4

struct LINK
{
   struct LINK   *prev;         // Ve@
   struct LINK   *next;         // VU@
   unsigned char block_handle;  // ݩ󨺤@ BLOCK TABLE (̤ji޲z 256x1024 )
   int           block_mark;    // ϥΪŶ BLOCK  mark s
   unsigned char data_handle;   // sƪ DATA TABLE (̤ji޲z 256x16K=4M Ŷ)
   int           data_mark;     // ϥΪŶ DATA TABLE (fmark  (fmark+size))
   unsigned char data_size;     // ϰ, ƪ 16 x data_size
};

struct BLOCK                    // LINK ϥΰO
{
   char          data[1024][15];// 15K Ŷ, s LINK 
   unsigned char mark[128];     // 򥻨ϥγ 16 bytes, i 16 K
   unsigned      block_handle;  //
   int           useable;       // ϰ|iΪ
   struct BLOCK  *prev;         // W@Ӧsϰ
   struct BLOCK  *next;         // U@Ӧsϰ
};

struct DATA                     // ƨϥΰO
{
   unsigned char mark[128];     // 򥻨ϥγ 16 bytes, i 16K
   int           useable;       // ϰ|iΪ
   char          data_handle;   // data handle
   char          *data;         // ڦsư
   char          ems_handle;    // ڦsư
   struct DATA   *prev;         // W@Ӧs HANDLE
   struct DATA   *next;         // U@Ӧs HANDLE
};

struct LINE_STRUCT
{
    int SCRY   ;                //  SCRY   =1    rϪ̫e
    int SCRY1  ;                //  SCRY1  =22   rϪ̫
    int COMMAND;                //  COMMAND=23   ROCҦb
    int STATUS ;                //  STATUS =24   ACҦb
    int MESSAGE;                //  MESSAGE=25   TCҦb
};

struct POS_STRUCT
{
    int MAXY;                   //  MAXY =1      ثe̤j
    int NOWY;                   //  NOWY =1      ثe Y y
    int NOWX;                   //  NOWX =1      ثe X y
    int SCRY;                   //  SCRY =1      ù     Y y
    int SCRX;                   //  SCRX =1      ù     X y
    int MARX;                   //  MARX =0      ثe X y
    int MARKY,MARKY1;           //  MARKY=MARKY1=0
    int MARKX,MARKX1;           //  MARKX=MARKX1=0  LINE MARK  0
    int OLDY,OLDY1;             //  OLDY =1  ʧ@e SCRY , OLDY1 ʧ@e NOWY
    int CMD_NOWX;               //  CMD_NOWX=1
    int CMD_SCRX;               //  CMD_SCRX=1
    int CMD_MARX;               //  CMD_MARX=0
    int CURY;                   //  CURY=0 CLIENT  COMMAND ɴЩҦb
    int CURX;                   //  CURX=0
};

struct CTRL_STRUCT
{
    int MODIFY;                 //  MODIFY   =OFF  O_wק
    int INSERT;                 //  INSERT   =OFF  O_JҦ
    int COMMAND;                //  COMMAND  =OFF  O_bROC
    int EXIT;                   //  EXIT     =OFF  O_
    int MARK;                   //  MARK     =OFF  O_QаO
    int MESSAGE;                //  MESSAGE  =OFF  O_TQ
    struct BACKUP *MARKFILE;    //  MARKFILE =NULL ثe@ɮ׳Q MARK
    int KEYLOCK;                //  KEYLOCK  =OFF  ثeLO_QLOCK
    int CHINESE;                //  CHINESE  =ON   ثeO_b媬A
    int MACRO;                  //  MACRO    =OFF  ثeO_b檬A
    int INIT;                   //  EditInit =ON   }ɮɬO_s ( Ctrl-Enter, relation open ɳ] OFF)
    int PROKEY;                 //  PROKEY   =OFF  O_O ProfileKey b
    int CHANGJEI;               //  CHANGJEI =OFF  ثeJA
};

struct DISPLAY_STRUCT
{
    int REDISPLAY;              //  REDISPLAY=OFF  O_s
    int SCRY;                   //  SCRY     =1    q SCRY ,s
    int CNT;                    //  CNT      =0    s CNT 
};

struct SET_STRUCT
{
   int SEARCHCASE;              // jpg      =OFF 0=OFF     1=ON
   int TIMER;                   // ɭp        =ON  0=OFF     1=ON
   int BEEP;                    // BEEP        =ON  0=OFF     1=ON
   int RELATION;                // RELATION    =ON  0=OFF     1=ON
   int AUTOPAGE;                // ۰ʸ    =OFF 0=OFF     1=ON
   int DIR;                     // dir Ƨ   1=NAME  2=DATE 3=SIZE
   int SHARE;                   // ICL    =OFF 0=OFF     1=ON
   int AUTOSAVE;                // ۰ʦs   0=OFF   ELSE      ON
   int SLEEP;                   // ίv]w   0=OFF   ELSE    
   int EDITCOLOR;               // rC
};

struct PUSH_STRUCT
{
    int CTRL;                   //  CTRL =OFF      O_ PUSH MARK
    int CTRL_MARK;              //  CTRL_MARK=OFF  PUSH MARK e CTRL.MARK A
    struct BACKUP *MARKFILE;    //  MARKFILE =NULL PUSH MARK e CTRL.MARKFILE A
    int MARKY, MARKY1;          //  MARKY=MARKY1=0
    int MARKX, MARKX1;          //  MARKX=MARKX1=0
};

struct BACKUP                   // hɶ}Ү, C@}ɮתݩʸƳƥ
{
   struct POS_STRUCT    POS;
   struct CTRL_STRUCT   CTRL;
   struct LINK          *NOW;
   struct LINK          *HEAD;
   struct LINK          *TAIL;
   char                 CMD_TEXT[256];
   char                 FNAME[80];
   struct BACKUP        *prev;
   struct BACKUP        *next;
};

// ---------------- }ɮɤ@ŪJ 512  bytes ----------------
struct FGETS_STRUCT
{
   char data[513];
   int  len;
   int  cnt;
};

// -------------- ICLɤ@ŪJ 512  bytes --------------
struct FPRNS_STRUCT
{
   char data[513];
   int  len;
   int  cnt;
};

// ------ OW䪬A, ΥHP_O_s Alt-L, Alt-B ----
struct LAST_STRUCT
{
   int  keystatus;
   int  code;
};

struct UNDO_STRUCT
{
   int         open;                    // Undo file Q OPEN
   int         append;                  //  append  =ON, ~ Undo append
   int         release;                 //  release =ON, ~ Undo release
   int         memory_full;             //  memory  =OFF,~ Undo append
};

struct MACRO_STRUCT
{
    int  debug;                         // ثeO_b DEBUG Ҧ
    int  loop;                          // ثeO_b Loop  Ҧ
    long loop_pos;                      // V loop }l tell()
    int  loop_times;                    // Loop 
};

struct PROKEY_STRUCT
{
    int                   funckey;
    int                   keystatus;
    int                   code;
    struct PROKEY_STRUCT  *next;
    char                  *macro;       // Vep [MarkBlock][Down]
};

struct STRINGCOLOR_STRUCT               // Sr, C
{
    int                   cnt;
    char                  str[33][9];
    int                   color[33];
};

// --------------------------------------------------------------
// --------------------------------------------------------------
void  AutoSave(char *fname);
void  AutoSaveProcess(void);
void  AutoSaveUnlink(char *fname);
int   AltSymbol(unsigned ch);
void  AltSymbolDisplay(int sel, char *str1, char *str2);

void  BackTabWord(void);
void  BeginLine(void);                   // 勵W@
void  BeginWord(void);

double Calc(char *str);
int   Change(char *old_str, char *new_str, int mode);
int   ChangeCase(int mode);              // MARK ϰjpg (1) jg (0) pg
void  ChangeEditStatus(struct BACKUP *BAKtmp);
void  ChangeFile(struct BACKUP *BAKnew);
void  ChangeMessage(void);
void  ChineseMode(void);
void  ClearCommandLine(void);            // command 槹, M command line
void  ClearLine(void);                   // ЩҦbMť,òܦ歺 (F5)
void  CmdLine(int liney);
void  Column(int column);                // w column
void  CommandMode(int ch);
void  CommandRepeat(int mode);           // ФeUO  0:DOWN 1:UP
void  CommandSave(char *str);            // xsUO
void  CommandToggle(void);               // ESC
void  CompareRedraw(int scry, int cnt);                          // P_sܰϰ
void  CompareRedrawArea(int line1, int line2,int *scr,int *cnt); // psܰϰ
void  CopyFromCommand(void);             // Ctrl-F
void  CopyToCommand(void);               // Ctrl-T
void  CursorCommand(void);               // Nв command line

void  DeleteBlock(int liney1, int liney2,int linex1, int linex2);   // Alt-D
void  DeleteChar(void);                  // Del
void  DeleteLine(int line1, int line2);  // Alt-D , Ctrl-BS
int   Delete(char *old_str, int mode);   // D/ /[*][*m]
void  DisplayFname(char *fname);
void  DisplayMark(int scry, int cnt);    // sܳQ MARK ϰ
void  DisplayMessage(char *str, int mode);
void  DisplayMessageNoBeep(char *str);
void  Dos(char *command);

int   Edit(char *fname);
int   Edit1(char *fname);
void  EditMode(int ch);
void  EndWord(void);
void  EraseEndLine(void);                // ЩҦb橳Mť (F6)
void  Execute(void);

int   Fgets(int fhandle, char *str, int init);

int   GetMinute(void);                  // oثeɶ()
char  Getch(void);

void  InitAll(void);
void  InsertLine(void);                  // ФUJ@ (ENTER)
void  InsertToggle(void);                // Ins
int   Insert(char *fname);               // O Insert
int   Interval(unsigned long *time1,int);// Cj 1 @ɶ{

void  Join(void);                        // Alt-J

void  KeyNormal(int ch);

void  LightLine(void);                   // w[jG
void  Line(char *line_str);
void  LineExchange(int mode);            // 1)VW  2)VU
int   Locate(char *str);
int   LowerCase(void);                   // MARK ϰpg  ChangeCase(0) Ctrl-C
void  ListOpen(void);                    // ثew}ɮײM

int   MallocData(struct LINK *tmp,char *data);
void  MenuProcess(void);
void  MainSub(char *fname,int code);

void  NextFile(void);
void  NowdataToText(struct LINK *tmp);
void  Number(char *ts1, char *ts2);

void  OpenCursorFile(void);

void  Phrase(void);
void  PhraseSelect(char cmd[][80], int cnt);
int   PhraseString(char *pstr, char *key_str);
char *PhraseStrtok(char *ts, char *ss, char lc, char rc);

void  PointerData(struct LINK *);
void  PopCommand(void);
void  Print(void);
void  PrintShare(void);
void  PrintMark(void);
void  PrintMarkShare(void);
void  PrintShareChar(void);
void  PrintShareStop(void);
void  PrinterBackgroundProcess(void);    // ICLBz{

int   Quit(void);
int   Quit1(void);
int   QuitAll(void);

void  Redraw(int scry,int cnt);          // qù scry ,s cnt 
void  Refresh(void);                     // sܿù
void  Arrange(void);                     // q
void  RollDown(int cnt, int x, int y, int x1, int y1, int attribute);
void  RollUp(int cnt, int x, int y, int x1, int y1, int attribute);
void  Result(void);

int   Save(char *fname);
int   SaveMark(char *fname);
int   Search(char *fname, char *keystr);
int   SearchString(char *fname, char *string);
void  ShiftLeft(int code);               // MARK ϦV
void  ShiftRight(int code);              // MARK ϦVk
void  Slipt(void);                       // Alt-S
void  StatusXY(void);
void  Status(void);
void  Symbol(void);                      // CTRL-TAB Ÿ
void  SetStringColor(char *kstr, int scry);
void  SleepEnableProcess(void);          // Ұʺίv˸m
int   SleepDisableProcess(void);         // Ѱίv˸m

void  Table(void);                       // Alt-TAB  
void  TabWord(void);
int   TimeDisplay(char *str,int mode);
void  TimerDisplayProcess(void);
void  ThanksProcess(void);
void  TransparentOn(void);
void  TransparentOff(void);
int   Transparent(void);

void  UndoLine(void);                    // SHIFT-F4
void  UnMark(void);                      // Alt-U
int   UpperCase(void);                   // MARK ϰjg  ChangeCase(1) Ctrl-C

void  Words(void);
//int   Window95(int ch);

struct DATA  *DATAalloc(void);
struct DATA  *DATAPointer(struct LINK *LINKtmp);
char         *DATAPointerData(struct LINK *LINKtmp);
void          DATAStatus(struct LINK *);

struct BLOCK *BLOCKPointer(struct LINK *LINKtmp);
struct BLOCK *BLOCKalloc(void);

#include "csf.h"
